/***************************************************************
 * Name:      tideMain.cpp
 * Purpose:   Code for Application Frame
 * Author:    Davor Cihlar (davor@cihlar.biz)
 * Created:   2008-06-14
 * Copyright: Davor Cihlar (http://davor.cihlar.biz/)
 * License:
 **************************************************************/

#include "wx_pch.h"
#include "tideMain.h"

#include <wx/msgdlg.h>
#include <wx/textfile.h>

//(*InternalHeaders(tideFrame)
#include <wx/artprov.h>
#include <wx/bitmap.h>
#include <wx/intl.h>
#include <wx/image.h>
#include <wx/string.h>
//*)


#define MAX_PLAY_TIME 700

#define TSTUP_ULAZ  0
#define TSTUP_ZAPIS 1
#define TSTUP_POMAK 2
#define TSTUP_NEXT  3

const wxColour tcol_Trace(164, 164, 255);
const wxColour tcol_Error(255, 0, 255);
const wxColour tcol_BreakPoint(255, 128, 128);
const wxColour tcol_Pocetno(164, 255, 164);

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

static wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(tideFrame)
const long tideFrame::ID_GRID1 = wxNewId();
const long tideFrame::ID_CUSTOM1 = wxNewId();
const long tideFrame::ID_SPLITTERWINDOW1 = wxNewId();
const long tideFrame::idMenuFileOpen = wxNewId();
const long tideFrame::idFileTraka = wxNewId();
const long tideFrame::idMenuFileQuit = wxNewId();
const long tideFrame::idMenuStanjeFind = wxNewId();
const long tideFrame::idMenuAutomatRun = wxNewId();
const long tideFrame::idMenuAutomatReset = wxNewId();
const long tideFrame::idMenuAutomatTrace = wxNewId();
const long tideFrame::idMenuBreakPoint = wxNewId();
const long tideFrame::idMenuAbout = wxNewId();
const long tideFrame::idTBOpen = wxNewId();
const long tideFrame::idTBRun = wxNewId();
const long tideFrame::idTBReset = wxNewId();
const long tideFrame::idTBTrace = wxNewId();
const long tideFrame::idTBBreakPoint = wxNewId();
const long tideFrame::ID_TOOLBAR1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(tideFrame,wxFrame)
    //(*EventTable(tideFrame)
    //*)
    EVT_LISTBOX_DCLICK(ID_CUSTOM1, tideFrame::OnTrakaDblClick)
END_EVENT_TABLE()

tideFrame::tideFrame(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(tideFrame)
    wxMenuItem* MenuItem2;
    wxMenu* Menu3;
    wxMenuItem* MenuItem1;
    wxMenu* Menu1;
    wxMenuItem* MenuItem6;
    wxMenuBar* MenuBar1;
    wxMenu* Menu2;

    Create(parent, wxID_ANY, _("Turing stroj IDE"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("wxID_ANY"));
    {
    	wxIcon FrameIcon;
    	FrameIcon.CopyFromBitmap(wxBitmap(wxImage(_T("pix/ikona.png"))));
    	SetIcon(FrameIcon);
    }
    SplitterWindow1 = new wxSplitterWindow(this, ID_SPLITTERWINDOW1, wxDefaultPosition, wxDefaultSize, wxSP_3D, _T("ID_SPLITTERWINDOW1"));
    SplitterWindow1->SetMinSize(wxSize(40,40));
    SplitterWindow1->SetMinimumPaneSize(10);
    Grid1 = new wxGrid(SplitterWindow1, ID_GRID1, wxPoint(39,-112), wxSize(400,110), 0, _T("ID_GRID1"));
    Grid1->CreateGrid(0,4);
    Grid1->SetMinSize(wxSize(40,20));
    TrakeList = new wxSimpleHtmlListBox(SplitterWindow1,ID_CUSTOM1,wxPoint(24,332),wxDefaultSize,0,NULL,wxHLB_DEFAULT_STYLE,wxDefaultValidator,_T("ID_CUSTOM1"));
    SplitterWindow1->SplitHorizontally(Grid1, TrakeList);
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem3 = new wxMenuItem(Menu1, idMenuFileOpen, _("&Open\tCtrl+O"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuItem3);
    MenuItem7 = new wxMenuItem(Menu1, idFileTraka, _("Učitaj &trake"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuItem7);
    MenuItem1 = new wxMenuItem(Menu1, idMenuFileQuit, _("&Quit\tAlt-F4"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("&File"));
    Menu4 = new wxMenu();
    MenuItem9 = new wxMenuItem(Menu4, idMenuStanjeFind, _("&Traži\tCtrl+F"), wxEmptyString, wxITEM_NORMAL);
    Menu4->Append(MenuItem9);
    MenuBar1->Append(Menu4, _("&Stanje"));
    Menu3 = new wxMenu();
    MenuItem4 = new wxMenuItem(Menu3, idMenuAutomatRun, _("&Run\tF5"), wxEmptyString, wxITEM_NORMAL);
    Menu3->Append(MenuItem4);
    MenuItem6 = new wxMenuItem(Menu3, idMenuAutomatReset, _("Re&set\tF12"), wxEmptyString, wxITEM_NORMAL);
    Menu3->Append(MenuItem6);
    MenuItem5 = new wxMenuItem(Menu3, idMenuAutomatTrace, _("&Trace\tF11"), wxEmptyString, wxITEM_NORMAL);
    Menu3->Append(MenuItem5);
    MenuItem8 = new wxMenuItem(Menu3, idMenuBreakPoint, _("Toggle &breakpoint\tF8"), wxEmptyString, wxITEM_NORMAL);
    Menu3->Append(MenuItem8);
    MenuBar1->Append(Menu3, _("&Automat"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, idMenuAbout, _("&About\tF1"), wxEmptyString, wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("&Help"));
    SetMenuBar(MenuBar1);
    ToolBar1 = new wxToolBar(this, ID_TOOLBAR1, wxDefaultPosition, wxDefaultSize, wxTB_HORIZONTAL|wxNO_BORDER, _T("ID_TOOLBAR1"));
    ToolBarItem1 = ToolBar1->AddTool(idTBOpen, _("Open"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FILE_OPEN")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("Učitaj automat"), wxEmptyString);
    ToolBar1->AddSeparator();
    ToolBarItem2 = ToolBar1->AddTool(idTBRun, _("Run"), wxBitmap(wxImage(_T("pix/start.png"))), wxNullBitmap, wxITEM_NORMAL, _("Pokreni automat"), wxEmptyString);
    ToolBarItem3 = ToolBar1->AddTool(idTBReset, _("Reset"), wxBitmap(wxImage(_T("pix/reset.png"))), wxNullBitmap, wxITEM_NORMAL, _("Reinicijalizira automat"), wxEmptyString);
    ToolBarItem4 = ToolBar1->AddTool(idTBTrace, _("Trace"), wxBitmap(wxImage(_T("pix/trace.png"))), wxNullBitmap, wxITEM_NORMAL, _("Izvrši jedno stanje"), wxEmptyString);
    ToolBarItem5 = ToolBar1->AddTool(idTBBreakPoint, _("Toggle breakpoint"), wxBitmap(wxImage(_T("pix/breakpoint.png"))), wxNullBitmap, wxITEM_NORMAL, _("Toggle breakpoint"), wxEmptyString);
    ToolBar1->Realize();
    SetToolBar(ToolBar1);
    FileDialog = new wxFileDialog(this, _("Odaberi datoteku s automatom"), wxEmptyString, wxEmptyString, _("Turingov stroj (*.ts)|*.ts"), wxFD_DEFAULT_STYLE, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
    TrakeFileDialog = new wxFileDialog(this, _("Odaberi datoteku sa trakama"), wxEmptyString, wxEmptyString, _("Tekstualne datoteke (*.txt)|*.txt"), wxFD_DEFAULT_STYLE, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));

    Connect(ID_GRID1,wxEVT_GRID_CELL_LEFT_DCLICK,(wxObjectEventFunction)&tideFrame::OnGrid1CellLeftDClick);
    Connect(idMenuFileOpen,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&tideFrame::OnFileOpen);
    Connect(idFileTraka,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&tideFrame::OnFileUcitajTrake);
    Connect(idMenuFileQuit,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&tideFrame::OnQuit);
    Connect(idMenuStanjeFind,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&tideFrame::OnStanjeTrazi);
    Connect(idMenuAutomatRun,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&tideFrame::OnAutomatRun);
    Connect(idMenuAutomatReset,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&tideFrame::OnAutomatReset);
    Connect(idMenuAutomatTrace,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&tideFrame::OnAutomatTrace);
    Connect(idMenuBreakPoint,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&tideFrame::OnAutomatBreakpoint);
    Connect(idMenuAbout,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&tideFrame::OnAbout);
    Connect(idTBOpen,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&tideFrame::OnFileOpen);
    Connect(idTBRun,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&tideFrame::OnAutomatRun);
    Connect(idTBReset,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&tideFrame::OnAutomatReset);
    Connect(idTBTrace,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&tideFrame::OnAutomatTrace);
    Connect(idTBBreakPoint,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&tideFrame::OnAutomatBreakpoint);
    //*)

    SplitterWindow1->SetSashGravity(1.0);

    Grid1->SetColLabelValue(TSTUP_ULAZ, _("Ulaz"));
    Grid1->SetColLabelValue(TSTUP_ZAPIS, _("Zapis"));
    Grid1->SetColLabelValue(TSTUP_POMAK, _("Pomak"));
    Grid1->SetColLabelValue(TSTUP_NEXT, _("Prijelaz"));
    Grid1->EnableDragRowSize(false);

    ResetTracePrikaz();
    stroj.RegisterTraceHandler(Turing::Handler(StrojTraceHandler, this));
}

tideFrame::~tideFrame()
{
    //(*Destroy(tideFrame)
    //*)
}

void tideFrame::ResetTracePrikaz() {
    proslo_oznaceno = NULL;
}

void tideFrame::StrojTraceHandler(Turing *stroj, void *_dis) {
    tideFrame *dis = (tideFrame*)_dis;

    if (dis->proslo_oznaceno)
        dis->StilizirajStanje(dis->proslo_oznaceno);
    dis->proslo_oznaceno = stroj->GetTrenutno();

    if (stroj->GetTrenutno()) {
        dis->StilizirajStanje(stroj->GetTrenutno(), true);
    }

    dis->Grid1->ForceRefresh();
}

void tideFrame::TrakaChangeHandler(TuringTraka *t, void *_dis) {
    tideFrame *dis = (tideFrame*)_dis;
    int tid;

    for (tid = 0; tid < dis->stroj.GetNumTraka(); ++tid) {
        if (t == &dis->stroj.Traka[tid]) {
            dis->ObnoviTraku(tid);
            break;
        }
    }
}

void tideFrame::ReportTraceError(int err) {
    wxString msg;

    switch (err) {
        case -1:
            msg = _("Automat nije inicijaliziran!");
            break;
        case 0:
            msg = _("Sve OK.");
            break;
        case 1:
            msg = _("Nema definiranog prijelaza!");
            break;
        case 2:
            msg = _("Prijelaz u nedefinirano stanje!");
            break;
        case 3:
            msg = _("Ne može izvršiti nedefinirano stanje!");
            break;
        case 4:
            msg = _("Ne može ići lijevije po traci!");
            break;

        default:
            msg.Printf(_("Nepoznata greška: %d!"), err);
            break;
    }

    wxMessageBox(msg, _("Greška kod simulacije"), wxICON_ERROR);
}

void tideFrame::ObnoviTrake() {
    TrakeList->Clear();
    for (int i = 0; i < stroj.GetNumTraka(); ++i) {
        TrakeList->AppendString(wxString());
        ObnoviTraku(i);
    }
}

void tideFrame::ObnoviTraku(int t) {
    if (stroj.Traka[t].empty()) {
        TrakeList->SetString(t, _("<i>Traka je prazna</i>"));
    } else {
        wxString td(stroj.Traka[t].c_str(), wxConvLibc);
        if (stroj.Traka[t].GetPozicija() >= stroj.Traka[t].size()) {
            td += _("<b>_</b>");
        } else {
            td.insert(stroj.Traka[t].GetPozicija() + 1, _("</b></u>"));
            td.insert(stroj.Traka[t].GetPozicija(), _("<u><b>"));
        }
        TrakeList->SetString(t, _("<pre>") + td + _("</pre>"));
    }
}

bool tideFrame::ImaBreakPoint(const TuringStanje *ts) const {
    return breakpoint.find(ts) != breakpoint.end();
}

wxGridCellAttr * tideFrame::GetStanjeCellAttr(const TuringStanje *st) const {
    wxGridCellAttr * gca = new wxGridCellAttr();

    gca->SetReadOnly(true);

    if (!st) {
        gca->SetBackgroundColour(tcol_Error);
        return gca;
    }

    if (ImaBreakPoint(st)) {
        gca->SetBackgroundColour(tcol_BreakPoint);
    } else {
        if (stroj.GetPocetno() == st)
            gca->SetBackgroundColour(tcol_Pocetno);
    }

    if (stroj.GetTrenutno() == st) {
        wxColour nc = gca->GetBackgroundColour();
        if (nc.Alpha() == wxALPHA_TRANSPARENT) nc = tcol_Trace;
        else nc.Set((nc.Red() + tcol_Trace.Red()) / 2, (nc.Green() + tcol_Trace.Green()) / 2, (nc.Blue() + tcol_Trace.Blue()) / 2);
        gca->SetBackgroundColour(nc);
    }

    return gca;
}

void tideFrame::UbaciPrijelaz(const TuringStanje &stanje, const TuringUlaz &ulaz, const TuringAkcija &akcija) {
    int row = Grid1->GetNumberRows();
    wxString s;

    Grid1->AppendRows(1);

    Grid1->SetRowLabelValue(row, wxString(stanje.GetNaziv().c_str(), wxConvLibc));

    if (ulaz == TuringUlaz()) {
        s = stanje.akcija.size() > 1 ? _("Inače") : _("Uvijek");
    } else {
        s.erase();
        for (TuringUlaz::const_iterator u = ulaz.begin(); u != ulaz.end(); ++u) {
            wxString ts;
            ts.Printf(_("@%d'%c' "), u->first, u->second);
            s += ts;
        }
    }
    Grid1->SetCellValue(row, TSTUP_ULAZ, s);

    s.erase();
    for (map<const int, char>::const_iterator z = akcija.zapis.begin(); z != akcija.zapis.end(); ++z) {
        wxString ts;
        ts.Printf(_("@%d'%c' "), z->first, z->second);
        s += ts;
    }
    Grid1->SetCellValue(row, TSTUP_ZAPIS, s);

    Grid1->SetCellValue(row, TSTUP_POMAK, wxString(akcija.pomak.c_str(), wxConvLibc));

    Grid1->SetCellValue(row, TSTUP_NEXT, wxString(akcija.iduce ? akcija.iduce->GetNaziv().c_str() : "NULL", wxConvLibc));

    Grid1->SetRowAttr(row, GetStanjeCellAttr(&stanje));
}

void tideFrame::ObnoviPrijelaze() {
    const ListaStanja & st = stroj.GetStanja();
    wxString s;

    Grid1->BeginBatch();

    Grid1->DeleteRows(0, Grid1->GetNumberRows());

    for (ListaStanja::const_iterator i = st.begin(); i != st.end(); ++i) {
        const TuringUlaz *uulaz = NULL;
        const TuringAkcija *uakcija = NULL;
        for (TuringStanje::ListaAkcija::const_iterator a = i->second.akcija.begin(); a != i->second.akcija.end(); ++a) {
            if (a->first != TuringUlaz()) {
                UbaciPrijelaz(i->second, a->first, a->second);
            } else {
                uulaz = &a->first;
                uakcija =&a->second;
            }
        }
        if (uulaz) UbaciPrijelaz(i->second, *uulaz, *uakcija);
    }

    Grid1->AutoSize();

    Grid1->EndBatch();

    SplitterWindow1->UpdateSize();
}

void tideFrame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void tideFrame::OnAbout(wxCommandEvent& event)
{
    wxString msg = wxbuildinfo(long_f);
    msg = _("IDE za Turingov stroj\n"
            "By Davor Cihlar\n"
            "\n") +
            msg;
    wxMessageBox(msg, _("O programu"));
}

void tideFrame::OnFileOpen(wxCommandEvent& event)
{
    FileDialog->SetWindowStyleFlag(wxFD_OPEN | wxFD_FILE_MUST_EXIST);
    if (FileDialog->ShowModal() != wxID_OK)
        return;

    if (!stroj.Ucitaj((const char *)FileDialog->GetPath().mb_str(wxConvFile))) {
        wxMessageBox(_("Ne mogu učitati datoteku!"), _("Greška"), wxICON_ERROR);
        return;
    }
    ObnoviTrake();
    ObnoviPrijelaze();
    ResetTracePrikaz();
    for (int i = 0; i < stroj.GetNumTraka(); ++i) {
        stroj.Traka[i].RegisterChangeHandler(TuringTraka::Handler(TrakaChangeHandler, this));
        stroj.Traka[i].RegisterMoveHandler(TuringTraka::Handler(TrakaChangeHandler, this));
    }
}

void tideFrame::OnTrakaDblClick(wxCommandEvent& event)
{
    wxString text, title;
    int id = event.GetSelection();

    title.Printf(_("Traka %d"), id);
    text.Printf(_("Sadržaj %d trake:"), id);
    wxTextEntryDialog *ted = new wxTextEntryDialog(this, text, title, wxString(stroj.Traka[id].c_str(), wxConvLibc));
    if (ted->ShowModal() == wxID_OK)
        stroj.Traka[id] = (const char *)ted->GetValue().mb_str(wxConvLibc);
    ted->Destroy();
}

void tideFrame::OnAutomatRun(wxCommandEvent& event)
{
    wxStopWatch stoperica;
    int err;

    if (!stroj.IsReady())
        stroj.Init();

    stroj.UnregisterTraceHandler();
    while (!(err = stroj.Trace())) {
        if (ImaBreakPoint(stroj.GetTrenutno()))
            goto run_kraj;
        if (stoperica.Time() > MAX_PLAY_TIME) {
            if (wxMessageBox(_("Stroj se možda zaglavio.\nDa li da nastavim sa izvršavanjem?"), _("Timeout"), wxICON_ERROR | wxYES_NO) == wxNO)
                goto run_kraj;
            stoperica.Start();
        }
    }

    ReportTraceError(err);

run_kraj:
    stroj.RegisterTraceHandler(Turing::Handler(StrojTraceHandler, this));
    StrojTraceHandler(&stroj, this);
}

void tideFrame::OnAutomatTrace(wxCommandEvent& event)
{
    int err;

    if (!stroj.IsReady()) {
        stroj.Init();
        return;
    }

    if ((err = stroj.Trace()))
        ReportTraceError(err);
}

void tideFrame::OnAutomatReset(wxCommandEvent& event)
{
    stroj.Init();
}

void tideFrame::OnFileUcitajTrake(wxCommandEvent& event)
{
    TrakeFileDialog->SetWindowStyleFlag(wxFD_OPEN | wxFD_FILE_MUST_EXIST);
    if (TrakeFileDialog->ShowModal() != wxID_OK)
        return;

    wxTextFile tf(TrakeFileDialog->GetPath());
    wxString l;

    if (!tf.Open())
        return;

    int i;
    l = tf.GetFirstLine();
    for (i = 0; i < stroj.GetNumTraka(); ++i) {
        stroj.Traka[i] = (const char *)l.mb_str(wxConvLibc);
        if (tf.Eof()) break;
        l = tf.GetNextLine();
    }

    for (++i; i < stroj.GetNumTraka(); ++i)
        stroj.Traka[i].erase();

    tf.Close();
}

void tideFrame::StilizirajStanje(const TuringStanje *ts, bool show, int _row) {
    const wxString wxsnaziv(ts->GetNaziv().c_str(), wxConvLibc);
    int row;

    if (_row > -1) {
        row = _row;
        goto skipsearch;
    }

    for (row = 0; row < Grid1->GetNumberRows(); ++row) {
        if (Grid1->GetRowLabelValue(row) == wxsnaziv) {
skipsearch:
            if (show) Grid1->MakeCellVisible(row, 0);
            wxGridCellAttr *ca = GetStanjeCellAttr(ts);
            for (; row < Grid1->GetNumberRows() && Grid1->GetRowLabelValue(row) == wxsnaziv; ++row)
                Grid1->SetRowAttr(row, ca);
            if (show) Grid1->MakeCellVisible(row - 1, 0);
            break;
        }
    }
}

void tideFrame::OnAutomatBreakpoint(wxCommandEvent& event)
{
    const TuringStanje *pts = NULL;
    wxArrayInt sr = Grid1->GetSelectedRows();
    int redak;

    Grid1->BeginBatch();

    for (size_t i = 0; i < sr.size(); ++i) {
        const TuringStanje *ts = stroj.FindStanje((const char *)Grid1->GetRowLabelValue(sr[i]).mb_str(wxConvLibc));
        if (!ts) continue;

        if (ts == pts) continue;
        pts = ts;

        for (redak = sr[i]; redak >= 0 && Grid1->GetRowLabelValue(redak) == Grid1->GetRowLabelValue(sr[i]); --redak);
        redak++;

        BreakPoints::iterator bp = breakpoint.find(ts);
        if (bp == breakpoint.end()) {
            breakpoint[ts] = redak;
        } else {
            breakpoint.erase(bp);
        }

        StilizirajStanje(ts, redak);
    }

    Grid1->EndBatch();
}

void tideFrame::OnGrid1CellLeftDClick(wxGridEvent& event)
{
    if (Grid1->GetGridCursorCol() != TSTUP_NEXT || Grid1->GetGridCursorRow() < 0)
        return;

    const wxString stnaz = Grid1->GetCellValue(Grid1->GetGridCursorRow(), TSTUP_NEXT);
    for (int i = 0; i < Grid1->GetNumberRows(); ++i) {
        if (Grid1->GetRowLabelValue(i) == stnaz) {
            Grid1->SelectRow(i);
            Grid1->MakeCellVisible(i, 0);
            return;
        }
    }

    wxMessageBox(_("Nije nađeno stanje na koje treba skočiti!"), _("Nema tog stanja"), wxICON_ERROR);
}

void tideFrame::OnStanjeTrazi(wxCommandEvent& event)
{
    wxTextEntryDialog *ted = new wxTextEntryDialog(this, _("Upiši ime traženog stanja:"), _("Traži"));

    if (ted->ShowModal() != wxID_OK) goto kraj;

    for (int i = 0; i < Grid1->GetNumberRows(); ++i) {
        if (Grid1->GetRowLabelValue(i) == ted->GetValue()) {
            Grid1->SelectRow(i);
            Grid1->MakeCellVisible(i, 0);
            goto kraj;
        }
    }

    wxMessageBox(_("Stanje \"") + ted->GetValue() + _("\" nije nađeno!"), _("Nema traženog stanja"), wxICON_INFORMATION);

kraj:
    ted->Destroy();
}
