/***************************************************************
 * Name:      tideMain.h
 * Purpose:   Defines Application Frame
 * Author:    Davor Cihlar (davor@cihlar.biz)
 * Created:   2008-06-14
 * Copyright: Davor Cihlar (http://davor.cihlar.biz/)
 * License:
 **************************************************************/

#ifndef TIDEMAIN_H
#define TIDEMAIN_H

#include "../turing/turing.h"

//(*Headers(tideFrame)
#include <wx/menu.h>
#include <wx/htmllbox.h>
#include <wx/splitter.h>
#include <wx/toolbar.h>
#include <wx/grid.h>
#include <wx/filedlg.h>
#include <wx/frame.h>
//*)



class tideFrame: public wxFrame
{
    public:

        tideFrame(wxWindow* parent,wxWindowID id = -1);
        virtual ~tideFrame();

    private:
        typedef map<const TuringStanje *, int> BreakPoints;

        Turing stroj;
        BreakPoints breakpoint;
        const TuringStanje *proslo_oznaceno;

        void ObnoviTrake();
        void ObnoviTraku(int t);
        void ObnoviPrijelaze();
        void ResetTracePrikaz();
        void ReportTraceError(int err);
        void StilizirajStanje(const TuringStanje *ts, bool show = false, int _row = -1);
        bool ImaBreakPoint(const TuringStanje *ts) const;
        wxGridCellAttr * GetStanjeCellAttr(const TuringStanje *ts) const;
        void UbaciPrijelaz(const TuringStanje &stanje, const TuringUlaz &ulaz, const TuringAkcija &akcija);

        static void StrojTraceHandler(Turing *stroj, void *_dis);
        static void TrakaChangeHandler(TuringTraka *t, void *dis);

        //(*Handlers(tideFrame)
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnMenuOpenSelected(wxCommandEvent& event);
        void OnFileOpen(wxCommandEvent& event);
        void OnAutomatRun(wxCommandEvent& event);
        void OnAutomatTrace(wxCommandEvent& event);
        void OnAutomatReset(wxCommandEvent& event);
        void OnFileUcitajTrake(wxCommandEvent& event);
        void OnAutomatBreakpoint(wxCommandEvent& event);
        void OnGrid1LeftDClick(wxMouseEvent& event);
        void OnGrid1CellLeftDClick(wxGridEvent& event);
        void OnStanjeTrazi(wxCommandEvent& event);
        //*)
        void OnTrakaDblClick(wxCommandEvent& event);

        //(*Identifiers(tideFrame)
        static const long ID_GRID1;
        static const long ID_CUSTOM1;
        static const long ID_SPLITTERWINDOW1;
        static const long idMenuFileOpen;
        static const long idFileTraka;
        static const long idMenuFileQuit;
        static const long idMenuStanjeFind;
        static const long idMenuAutomatRun;
        static const long idMenuAutomatReset;
        static const long idMenuAutomatTrace;
        static const long idMenuBreakPoint;
        static const long idMenuAbout;
        static const long idTBOpen;
        static const long idTBRun;
        static const long idTBReset;
        static const long idTBTrace;
        static const long idTBBreakPoint;
        static const long ID_TOOLBAR1;
        //*)

        //(*Declarations(tideFrame)
        wxToolBarToolBase* ToolBarItem4;
        wxMenuItem* MenuItem8;
        wxSimpleHtmlListBox* TrakeList;
        wxToolBar* ToolBar1;
        wxMenuItem* MenuItem7;
        wxToolBarToolBase* ToolBarItem3;
        wxMenuItem* MenuItem5;
        wxMenuItem* MenuItem4;
        wxFileDialog* FileDialog;
        wxGrid* Grid1;
        wxToolBarToolBase* ToolBarItem1;
        wxMenuItem* MenuItem3;
        wxToolBarToolBase* ToolBarItem5;
        wxSplitterWindow* SplitterWindow1;
        wxMenuItem* MenuItem9;
        wxFileDialog* TrakeFileDialog;
        wxToolBarToolBase* ToolBarItem2;
        wxMenu* Menu4;
        //*)

        DECLARE_EVENT_TABLE()
};

#endif // TIDEMAIN_H
