#include <stdio.h>

#include "turing.h"

static string ReadString(FILE *f) {
	char buf[1000];
	string r;
	while (fgets(buf, sizeof(buf), f))
		r += buf;
	while (r.size() && (*(r.end() - 1) == '\n' || *(r.end() - 1) == '\r'))
		r.erase(r.end() - 1);
	return r;
}

static void help(const char *exe) {
	printf("Upraba: %s datoteka_s_automatom ulazna_datoteka\n", exe);
}

int main(int argn, const char *argv[]) {
	Turing stroj;
	FILE *fi;

	if (argn != 3) {
		help(argv[0]);
		return 1;
	}

	if (!stroj.Ucitaj(argv[1])) {
		fprintf(stderr, "Ne mogu ucitati datoteku sa stanjima automata!\n");
		return 1;
	}

	if (!(fi = fopen(argv[2], "rt"))) {
		fprintf(stderr, "Ne mogu ucitati datoteku s ulaznim podacima!\n");
		return 1;
	}
	stroj.Traka[0] = ReadString(fi);
	fclose(fi);


	stroj.Simuliraj();
	stroj.DumpMemory();

	return 0;
}
